import asyncio
import traceback
from bd.bdmemoria import *
from selenium import webdriver
from selenium.webdriver.firefox.options import Options
from selenium.common.exceptions import InvalidSessionIdException, NoSuchWindowException
from funciones.mainselenium import *


def abrir_navegador(headless=False):
    opciones = Options()

    opciones.headless = headless

    driver = webdriver.Firefox(firefox_profile=os.getenv("RUTA_PERFIL"),
                               options=opciones,
                               executable_path=os.getenv("RUTA_GECKO"))

    driver.get("https://web.whatsapp.com/")

    sesion_iniciada = False

    while sesion_iniciada is False:
        try:
            driver.find_element_by_css_selector(ids['verificar_sesion'])
            sesion_iniciada = True
            print("<<<Sesion iniciada>>>")
        except:
            continue

    return driver


def iniciar(loop, *args):
    try:
        corutinas = [asyncio.ensure_future(coro[0](*coro[1])) for coro in args]

        print(f"[[ Corutinas a ejecutar: {len(corutinas)} ]]")

        loop.run_forever()

    except (InvalidSessionIdException, NoSuchWindowException, KeyboardInterrupt):
        print(f"\n[[ Finalizando programa ]]")
        loop.stop()
        quit()
    except Exception:
        print(traceback.format_exc())


async def ejecutar_tarea(tarea):
    print(f"[[ Ejecutando tarea ]]\n{tarea}")
    rta = await tarea()
    print(rta, len(rta), type(rta))


async def ejecutar_corutina(*tareas):
    coros = [ejecutar_tarea(tarea) for tarea in tareas]
    print(coros, len(coros), type(coros))
