import asyncio
import traceback
import os
from funciones.mainselenium import verificar_mensajes, monitorear_ventana, enviar_mensaje
from adaptadores.atapis import enviar_mensaje_del_usuario, obtener_mensajes_del_cliente
from bd.bdmemoria import *


async def monitorear_mensajes(conexion, driver):
    while True:
        print(f"[[ MONITOREANDO MENSAJES ]]")
        try:
            rta = verificar_mensajes(driver)

        except:
            print(traceback.format_exc())
            continue

        if rta['Dato']:
            mensajes = rta['Dato']

            insertar(conexion, 'mensajes', *mensajes)

        else:
            await asyncio.sleep(3)
            continue

        await asyncio.sleep(0.1)


async def monitorear_chat(conexion, driver):
    while True:
        print(f"[[ MONITOREANDO CHAT ]]")
        rta = None
        try:
            rta = monitorear_ventana(driver)
        except:
            print(traceback.format_exc())

        if rta['Estado'] is False:
            await asyncio.sleep(5)
            continue

        id_ultimo_mensaje_navegador = rta['Dato']['id_mensaje']

        ultimo_mensaje = obtener_id_ultimo_mensaje(conexion, rta['Dato']['telefono'])

        if len(ultimo_mensaje) > 0:
            id_ultimo_mensaje = ultimo_mensaje[-1]['id_mensaje']

            if id_ultimo_mensaje_navegador == id_ultimo_mensaje:
                await asyncio.sleep(5)
                continue

            else:
                print("INSERTANDING")
                rta['Dato']['estado'] = 'pendiente'
                insertar(conexion, 'mensajes', *rta['Dato'].values())

        await asyncio.sleep(0.1)


async def enviar_pendientes_a_usuarios(conexion, driver):
    while True:
        print(f"[[ ENVIANDO PENDIENTES EN NAVEGADOR ]]")
        # Obtenemos todos los mensajes pendientes para enviar a usuarios
        mensajes = obtener_mensajes_a_enviar(conexion)

        for mensaje in mensajes:

            try:
                # Buscamos el nombre agendado del usuario
                usuario = obtener_usuario(conexion, mensaje['telefono'])
                nombre_agendado = usuario['nombre_agendado']
            except:
                # Si no encontramos al usuario en la bd, lo agregamos
                insertar(conexion, 'usuarios', *(mensaje['telefono'],
                                                 mensaje['nombre_agendado']))
                nombre_agendado = mensaje['nombre_agendado']

            await enviar_mensaje(driver, mensaje['mensaje'], mensaje['telefono'], nombre_agendado)

            actualizar_mensaje_fila(conexion, mensaje['rowid'], 'enviado')
        await asyncio.sleep(0.1)


async def obtener_pendientes_y_enviar(conexion, host):
    while True:
        print(f"[[ OBTENIENDO PENDIENTES Y ENVIANDO ]]")
        pendientes = obtener_pendientes(conexion)

        for pendiente in pendientes:

            rta = await enviar_mensaje_del_usuario(telefono_origen=pendiente['telefono'],
                                                   telefono_destino=os.getenv('TELEFONO'),
                                                   mensaje=pendiente['mensaje'],
                                                   nombre=pendiente['nombre_agendado'],
                                                   hora_mensaje=pendiente['fecha_hora'],
                                                   clase=pendiente['clase'],
                                                   host=host)

            if rta['Estado']:
                actualizar_estado_mensaje(conexion, pendiente['id_mensaje'], 'enviado')

        await asyncio.sleep(0.1)


async def obtener_mensajes_para_enviar(conexion):
    while True:
        print(f"[[ OBTENIENDO MENSAJES PARA ENVIAR ]]")
        rta_pendientes = obtener_mensajes_del_cliente(os.getenv("TELEFONO"), os.getenv("IP_ATAPIS"))

        if rta_pendientes['Estado']:

            pendientes = rta_pendientes['Dato']

            for pendiente in pendientes:
                id_msj = insertar(conexion, 'fila', *(pendiente["telefono_destino"],
                                                      pendiente["mensaje"],
                                                      'pendiente',
                                                      pendiente['telefono_destino'],
                                                      pendiente['fecha_hora']))

        await asyncio.sleep(0.1)
