import logging
import datetime
import traceback
import sys
import os
import asyncio
import argparse
import concurrent.futures
from selenium.common.exceptions import InvalidSessionIdException, NoSuchWindowException

print(sys.platform)
if sys.platform == 'linux':
    sys.path.append(os.getcwd() + "/funciones")
else:
    sys.path.append(os.getcwd() + "\\funciones")

from estaticos.esquema_bd import *
from bd.bdmemoria import BaseDeDatos
from funciones.asincrono import *
from funciones.principales import *


logging.basicConfig(filename="atlog.log", level=logging.WARNING)

# Al ejecutar el servicio se le deben pasar los siguientes parámetros
parser = argparse.ArgumentParser(description='atwsp')

parser.add_argument(
    '-telefono',
    help='El telefono correspondiente al que esta en atapis',
    required=True
)

parser.add_argument(
    '-perfil',
    help='La ruta donde se encuentra el perfil de Firefox para correr Selenium',
    required=True
)

parser.add_argument(
    '-gecko',
    help='El telefono correspondiente al que esta en atapis',
    required=True
)

parser.add_argument(
    '-atapis',
    help='El telefono correspondiente al que esta en atapis',
    required=True
)

# Guardo los parámetros recibidos
args = []
args.extend(sys.argv)
args.pop(0)
args = parser.parse_args(args)

telefono = None
perfil_firefox = None
ruta_geckodriver = None

# Creamos las variables de entorno
if args.telefono is not None:
    os.environ['TELEFONO'] = args.telefono

if args.perfil is not None:
    os.environ['RUTA_PERFIL'] = args.perfil

if args.gecko is not None:
    os.environ['RUTA_GECKO'] = args.gecko

if args.gecko is not None:
    os.environ['IP_ATAPIS'] = f"http://{args.atapis}:901"


def bootstrap():
    conexion = crear_bd()

    crear_tabla(conexion, 'mensajes', **esq_mensajes)

    crear_tabla(conexion, 'fila', **esq_fila)

    crear_tabla(conexion, 'usuarios', **esq_usuarios)

    driver = abrir_navegador(headless=False)

    return conexion, driver


BD, driver = bootstrap()

loop = asyncio.get_event_loop()

iniciar(loop,
        (obtener_mensajes_para_enviar, (BD,)),
        (enviar_pendientes_a_usuarios, (BD, driver)),
        (monitorear_mensajes, (BD, driver)),
        (monitorear_chat, (BD, driver)),
        (obtener_pendientes_y_enviar, (BD, os.getenv("IP_ATAPIS"))),
        )


